#ifndef _MAKEFS_
#define _MAKEFS_
/********************************************************************/
/*  filename.h - Description                                        */
/*                                                                  */
/*      Unpublished Confidential Information of Hewlett-Packard     */
/*      Company. Do not disclose.  Copyright (c) Hewlett-Packard    */
/*      Company 1996. All rights reserved                           */
/*                                                                  */
/* The contents of this software are proprietary and confidential   */
/* the Hewlett- Packard Company, and are limited in distribution to */
/* those with a direct need to know.  Individuals having access to  */
/* this software are responsible for maintaining the                */
/* confidentiality of the content and for keeping the software      */
/* secure when not in use.  Transfer to any party is strictly       */
/* forbidden other than as expressly permitted in writing by        */
/* Hewlett-Packard Company.  Unauthorized transfer to or possession */
/* by any unauthorized party may be a criminal offense.             */
/*                                                                  */
/*                   RESTRICTED RIGHTS LEGEND                       */
/*                                                                  */
/*      Use,  duplication,  or disclosure by the                    */
/*      U. S. Government is subject to restrictions as set forth    */
/*      in subparagraph (c) (1) (ii) in the Rights in Technical     */
/*      Data and Computer Software clause in DFARS 252.227-7013     */
/*      or any other successor clause.                              */
/*                                                                  */
/*                       HEWLETT-PACKARD COMPANY                    */
/*                       3000 Hanover St.                           */
/*                       Palo Alto, CA  94304 U.S.A.                */
/*                                                                  */
/*      Rights for non-DOD U.S. Government Departments and Agencies */
/*      are as set forth in FAR 52.227-19 (c) (1,2) or any other    */
/*      successor clause.                                           */
/*                                                                  */
/*  makefs.h - structures and definitions for NSR volume initialization */
/*             utility                                                  */
/*  29.Oct.90 13:00                                                     */
/*  written by Karen Klemm                                              */
/*  Modification history:                                               */
/*                                                                      */
/************************************************************************/
/*
 $Source: /projects/HMS/nsr/udfOld/src/nsrHdrs/makefs.h,v $
 $Revision: 1.15 $      $Author: hmgr $
 $State: Exp $          $Locker:  $
 $Date: 96/05/30 14:53:13 $
 ********************************************************************/

#include "../nsrHdrs/def.h"
#include "../nsrHdrs/o_vfsops.h"
#include "../nsrHdrs/nsr.h"
#include "../nsrHdrs/mkvol.h"
#include "../nsrHdrs/o_proto.h"

#define ANCHOR_0        256                /* 1st anchor sector number */
#define VDS_LEN         100                /* length of volume descriptor sequence */
#define START_PVDS  (ANCHOR_0-VDS_LEN)     /* start of primary volume descriptor sequence */
#define START_FSD    (ANCHOR_0+1)          /* start of file system descriptor sequence */
#define FSDS_LEN         20                /* length of file system descriptor sequence */
#define START_PIT   (START_FSD+FSDS_LEN)   /* start of partition integrity ICB */

/* constants for WORM */ 
#define PIT_LEN_WORM      ICB_BLOCK_SIZE_WORM     /* length of partition integrity ICB */
#define START_UST        (START_PIT+PIT_LEN_WORM) /* start of unalloced space table ICB */
#define UST_LEN           ICB_BLOCK_SIZE_WORM     /* length of unalloced space table ICB */
#define START_FST        (START_UST+UST_LEN)      /* start of freed space table ICB */
#define FST_LEN           ICB_BLOCK_SIZE_WORM     /* length of freed space table ICB */
#define LOC_ROOT_WORM    (START_FST+FST_LEN)      /* location of root dir ICB */

/* constants for MO */
#define PIT_LEN_MO        ICB_BLOCK_SIZE_MO       /* length of partition integrity ICB */
#define START_USB        (START_PIT+PIT_LEN_MO)   /* start of unalloced space bitmap ICB */
/* must determine location of FSB, root dir as a function of disk size */

#define MAX_USD           61 /*# allocation desc's to exactly fit in 1 sector*/

#define CHARSETLIST      ((1 << CS2) + (1 << CS3) + (1 << CS4) + (1 << CS5) + (1 << CS8))

struct ond_info {
    UINT32  type;
    UINT32  numSectors;
};

struct fs_info {
    UINT32              SectorSize;
    UINT32              DiskSectors;
    UINT32              SectorsInBMap;
    UINT16              ICBsize;
    UINT16              IndirectSize;
    UINT16              StripeSize;
    UCHAR8              FileSystemType;
    UCHAR8              Type;
    UINT16              ADType;
    UINT16              VolSeqNumber;
    UINT16              VolumeSize;
    CHAR8               VolumeName[FILENAMESIZE];
    struct otfsSection  VolSection[1];
    otfsVendorField     vf;
};

#endif /* _MAKEFS_ */
