#ifndef _MKVOL_
#define _MKVOL_
/********************************************************************/
/*  mkvol.h - Header file for mkvol                                 */
/*                                                                  */
/*      Unpublished Confidential Information of Hewlett-Packard     */
/*      Company. Do not disclose.  Copyright (c) Hewlett-Packard    */
/*      Company 1996. All rights reserved                           */
/*                                                                  */
/* The contents of this software are proprietary and confidential   */
/* the Hewlett- Packard Company, and are limited in distribution to */
/* those with a direct need to know.  Individuals having access to  */
/* this software are responsible for maintaining the                */
/* confidentiality of the content and for keeping the software      */
/* secure when not in use.  Transfer to any party is strictly       */
/* forbidden other than as expressly permitted in writing by        */
/* Hewlett-Packard Company.  Unauthorized transfer to or possession */
/* by any unauthorized party may be a criminal offense.             */
/*                                                                  */
/*                   RESTRICTED RIGHTS LEGEND                       */
/*                                                                  */
/*      Use,  duplication,  or disclosure by the                    */
/*      U. S. Government is subject to restrictions as set forth    */
/*      in subparagraph (c) (1) (ii) in the Rights in Technical     */
/*      Data and Computer Software clause in DFARS 252.227-7013     */
/*      or any other successor clause.                              */
/*                                                                  */
/*                       HEWLETT-PACKARD COMPANY                    */
/*                       3000 Hanover St.                           */
/*                       Palo Alto, CA  94304 U.S.A.                */
/*                                                                  */
/*      Rights for non-DOD U.S. Government Departments and Agencies */
/*      are as set forth in FAR 52.227-19 (c) (1,2) or any other    */
/*      successor clause.                                           */
/*                                                                  */
/********************************************************************/
/*
 $Source: /projects/HMS/nsr/udfOld/src/nsrHdrs/mkvol.h,v $
 $Revision: 1.10 $      $Author: hmgr $
 $State: Exp $          $Locker:  $
 $Date: 96/05/30 14:53:17 $
 ********************************************************************/

/* mkvol status values and message numbers */
/* most of these are for the command line interface portion */

#define FAIL    -1
#define SUCCESS 0
#define BADSWITCHVAL 1
#define BADSWITCHCHAR 2
#define HELPLINE 3
#define BADVOLNAME 4
#define BADDEVID 5
#define BADADTYPE 6

#define SWITCHCHAR  '-'

#define MAXVOLIDLEN 32
#define MAXLOGIDLEN 128
#define MAXDEVIDLEN 32

#define REQUIRELOC 1
#define GET 1
#define PUT 2

struct vol_info {
    CHAR8 VolID[MAXVOLIDLEN];
    CHAR8 LogID[MAXLOGIDLEN];
    CHAR8 DevID[MAXDEVIDLEN];
    UINT32 PartStart;                       /* 0 based sector address */
    UINT32 PartLen;                         /* sectors */
    UINT32 BlkSize;                         /* bytes */
    UINT32 SectorSize;                      /* bytes */
    UINT32 DiskSectors;                     /* sectors */
    UCHAR8 MediaType;                       /* see NSR.H for fsType */
    CHAR8 CharSet[64];
    struct otfsSection VolSection[1];
};  

struct FindVDSFlags {
    unsigned int uPrimaryValid :1;
    unsigned int uReserveValid :1;
};

struct ReadVDSFlags {
    unsigned int uPVDValid :1;
    unsigned int uIUVDValid :1;
    unsigned int uPDValid :1;
    unsigned int uLVDValid :1;
    unsigned int uUASDValid :1;
};


#define _MKVOLH_READ

/* extern function definitions */

extern UINT16 FindVDS(struct otfs *fsp, struct FindVDSFlags *sFlags,
                      struct extent_ad *sPrimary,
                      struct extent_ad *sReserve);
extern UINT16 ReadVDS( struct otfs *fsp,
                       struct extent_ad sPrimary,
                       struct ReadVDSFlags *sFlags,
                       struct extent_ad *sPVDAdr,
                       struct extent_ad *sPDAdr,
                       struct extent_ad *sLVDAdr,
                       struct extent_ad *sUSDAdr,
                       struct extent_ad *sIUDAdr,
                       UINT32 *VDSLen);
extern UINT16 GetVolumeSpace( UINT32 Location,
                              UINT32 Length,
                              UINT16 Flags,
                              UINT32 *USDLen,
                              struct extent_ad  *SpaceMap,
                              UINT32 SectorSize);
extern INT32 WriteAnchor(struct otfs *fsp,
                         UINT32 Location,
                         struct AnchorVolDesPtr *Anchor,
                         UINT32 mainStart, 
                         UINT32 mainLength,
                         UINT32 reserveStart,
                         UINT32 reserveLength);
extern INT32 Write_nsrDescriptor(struct otfs *x,struct nsrDescriptor *data);
extern INT32 NextVDSExtent( struct otfs *x, struct extent_ad y, UINT32 *z);
extern INT32 WritePVD( struct otfs *x, UINT32 z, struct vol_info *y,UINT32 seqnum);
extern INT32 WriteUSD( struct otfs *x, UINT32 y, void *z,UINT32 seqnum);
extern INT32 WriteTerminator( struct otfs *x, UINT32 y);
extern UINT32 NextVolDesSeqNum( INT16 x, UINT32 y);
extern INT32 WritePD( struct otfs *x, UINT32 y, struct vol_info *z,
                      struct PartDesc *pd,UINT32 seqnum);
extern INT32 WriteLVD( struct otfs *x, UINT32 y, struct vol_info *z,struct LogVolDesc *lvd,
                       UINT32 seqnum);
extern void str2dstr( dstring *a, UCHAR8 b, char *c);

#endif /* _MKVOL_ */
