#ifndef NSRERRNO_H
#define NSRERRNO_H
/********************************************************************/
/*  nsrerrno.h - NSR errors only                                    */
/*                                                                  */
/*      Unpublished Confidential Information of Hewlett-Packard     */
/*      Company. Do not disclose.  Copyright (c) Hewlett-Packard    */
/*      Company 1996. All rights reserved                           */
/*                                                                  */
/* The contents of this software are proprietary and confidential   */
/* the Hewlett- Packard Company, and are limited in distribution to */
/* those with a direct need to know.  Individuals having access to  */
/* this software are responsible for maintaining the                */
/* confidentiality of the content and for keeping the software      */
/* secure when not in use.  Transfer to any party is strictly       */
/* forbidden other than as expressly permitted in writing by        */
/* Hewlett-Packard Company.  Unauthorized transfer to or possession */
/* by any unauthorized party may be a criminal offense.             */
/*                                                                  */
/*                   RESTRICTED RIGHTS LEGEND                       */
/*                                                                  */
/*      Use,  duplication,  or disclosure by the                    */
/*      U. S. Government is subject to restrictions as set forth    */
/*      in subparagraph (c) (1) (ii) in the Rights in Technical     */
/*      Data and Computer Software clause in DFARS 252.227-7013     */
/*      or any other successor clause.                              */
/*                                                                  */
/*                       HEWLETT-PACKARD COMPANY                    */
/*                       3000 Hanover St.                           */
/*                       Palo Alto, CA  94304 U.S.A.                */
/*                                                                  */
/*      Rights for non-DOD U.S. Government Departments and Agencies */
/*      are as set forth in FAR 52.227-19 (c) (1,2) or any other    */
/*      successor clause.                                           */
/*                                                                  */
/********************************************************************/
/*
 $Source: /projects/HMS/nsr/udfOld/src/nsrHdrs/nsrerrno.h,v $
 $Revision: 1.5 $       $Author: hmgr $
 $State: Exp $          $Locker:  $
 $Date: 96/05/30 14:53:21 $
 ********************************************************************/

#define SUCCESS          0

/* Optical Errors */
#define EPOSTFIELD      252     /* Postfield written */
#define ERESET          253     /* Drive reset or disk changed */
#define EBLKCHK         254     /* Empty Sector (read) or  */
                                /*  Overwrite (write)      */

/* Non-Unix System Errors */
#define EVOLOFFLINE     512     /* volume only partially mounted */
#define EVOLONLINE      513     /* volume already mounted */
#define EWRITEPROTECT   514     /* hardware write protect */
#define EVOLLOCKED      515     /* software write protect */
#define EFILELOCKED     516     /* file is read-only */
#define EEOF            517 

/* new errors for core code and utilities */
#define EOPTDEV         260
#define MEMORY          261     /* Temporary!!! */
#define EMEDSIZE        262
#define EOPTIO          1       /* duplicate define */
#define EBADSESZ        276
#define EBADVDS         333
#define ENOVDS          334
#define ENOUAS          335
#define EUSDOVF         255     /* USD Overflow */
#define ENOVDSFR        289
#define ENOVDSRM        290

/* Errors for magvol o_sys.c */
#define EOVRWRIT        -256    /* Achtung!  This needs to be moved ! */
#define EIOREQ          -259    /* Bad request */

#endif
