#ifndef _ONODE_
#define _ONODE_
/********************************************************************/
/*  o_node.h - Includes for otnode/vnode                            */
/*                                                                  */
/*      Unpublished Confidential Information of Hewlett-Packard     */
/*      Company. Do not disclose.  Copyright (c) Hewlett-Packard    */
/*      Company 1996. All rights reserved                           */
/*                                                                  */
/* The contents of this software are proprietary and confidential   */
/* the Hewlett- Packard Company, and are limited in distribution to */
/* those with a direct need to know.  Individuals having access to  */
/* this software are responsible for maintaining the                */
/* confidentiality of the content and for keeping the software      */
/* secure when not in use.  Transfer to any party is strictly       */
/* forbidden other than as expressly permitted in writing by        */
/* Hewlett-Packard Company.  Unauthorized transfer to or possession */
/* by any unauthorized party may be a criminal offense.             */
/*                                                                  */
/*                   RESTRICTED RIGHTS LEGEND                       */
/*                                                                  */
/*      Use,  duplication,  or disclosure by the                    */
/*      U. S. Government is subject to restrictions as set forth    */
/*      in subparagraph (c) (1) (ii) in the Rights in Technical     */
/*      Data and Computer Software clause in DFARS 252.227-7013     */
/*      or any other successor clause.                              */
/*                                                                  */
/*                       HEWLETT-PACKARD COMPANY                    */
/*                       3000 Hanover St.                           */
/*                       Palo Alto, CA  94304 U.S.A.                */
/*                                                                  */
/*      Rights for non-DOD U.S. Government Departments and Agencies */
/*      are as set forth in FAR 52.227-19 (c) (1,2) or any other    */
/*      successor clause.                                           */
/*                                                                  */
/********************************************************************/
/*
 $Source: /projects/HMS/nsr/udfOld/src/nsrHdrs/o_node.h,v $
 $Revision: 1.5 $       $Author: hmgr $
 $State: Exp $          $Locker:  $
 $Date: 96/05/30 14:53:26 $
 ********************************************************************/

/* flags */
#define OT_MOD              0x0001  /* node modified */
#define OT_INVAL            0x0002  /* node is invalid */
#define OT_RELE_PEND        0x0004  /* node waiting for release */
#define OT_INITIALIZED      0x0008  /* node has been read from disk */

#define OTA_RDONLY      0x01        /* file is read only            */
#define OTA_HIDDEN      0x02        /* file is hidden               */
#define OTA_SYSTEM      0x04        /* system file                  */
#define OTA_SYMLINK     0x08        /* File is symbolic link        */

/* otnode file and directory node operations vectors */
extern struct vnodeops otfs_fvnodeops;
extern struct vnodeops otfs_dvnodeops;

#endif /* _ONODEH_ */
