#ifndef _OPROTOH_
#define _OPROTOH_
/********************************************************************/
/*  o_proto.h - Prototype header for NSR                            */
/*                                                                  */
/*      Unpublished Confidential Information of Hewlett-Packard     */
/*      Company. Do not disclose.  Copyright (c) Hewlett-Packard    */
/*      Company 1996. All rights reserved                           */
/*                                                                  */
/* The contents of this software are proprietary and confidential   */
/* the Hewlett- Packard Company, and are limited in distribution to */
/* those with a direct need to know.  Individuals having access to  */
/* this software are responsible for maintaining the                */
/* confidentiality of the content and for keeping the software      */
/* secure when not in use.  Transfer to any party is strictly       */
/* forbidden other than as expressly permitted in writing by        */
/* Hewlett-Packard Company.  Unauthorized transfer to or possession */
/* by any unauthorized party may be a criminal offense.             */
/*                                                                  */
/*                   RESTRICTED RIGHTS LEGEND                       */
/*                                                                  */
/*      Use,  duplication,  or disclosure by the                    */
/*      U. S. Government is subject to restrictions as set forth    */
/*      in subparagraph (c) (1) (ii) in the Rights in Technical     */
/*      Data and Computer Software clause in DFARS 252.227-7013     */
/*      or any other successor clause.                              */
/*                                                                  */
/*                       HEWLETT-PACKARD COMPANY                    */
/*                       3000 Hanover St.                           */
/*                       Palo Alto, CA  94304 U.S.A.                */
/*                                                                  */
/*      Rights for non-DOD U.S. Government Departments and Agencies */
/*      are as set forth in FAR 52.227-19 (c) (1,2) or any other    */
/*      successor clause.                                           */
/*                                                                  */
/********************************************************************/
/*
 $Source: /projects/HMS/nsr/udfOld/src/nsrHdrs/o_proto.h,v $
 $Revision: 1.20 $      $Author: hmgr $
 $State: Exp $          $Locker:  $
 $Date: 96/05/30 14:52:52 $
 ********************************************************************/

#if SUN 
#undef ANSIC
#endif

#if (MACINTOSH || IBM || HP)
#define ANSIC
#endif

#if (SUN || HP )

#if HP

/* functions from O_SYS.c */
void *kmem_alloc (UINT32 size, UINT16 control);
void kmem_free (void *ptr, UINT32 oldSize, UINT16 control);
void *kmem_realloc (void *ptr, UINT32 newSize, UINT32 oldSize, UINT16 control);
INT16 bzero( char*, INT32);
extern void binval(struct vnode *devvp);

/* functions from VENEER.c */
INT32           otfs_mount_dcp();
INT32           otfs_root_dcp();
INT32           otvn_lookup_dcp();
INT32           otvn_create_dcp();

/* functions from VMAKEFS.c */
UINT32          makefs_dcp();


#endif /* HP */

/* functions from O_SYS.c */
void            print_fs_ICBlists();
INT32           otfs_mount();
INT32           otfs_unmount();
INT32           pit_write(struct otfs *fs,UCHAR8 newtype);
INT32           otvn_bmap();
INT32           otvn_link();
INT32           otvn_readlink();
INT32           otvn_strategy();
INT32           otvn_symlink();
INT32           ot_bflush();
INT32           ot_erase();
INT32           ot_fillBasicFS();
INT32           ot_getAttributes();
INT32           ot_getVolInfo();
INT32           ot_getTimeAndDate();
INT32           ot_lock_cart();
void            ot_lockfs();
INT32           ot_memCompare();
INT32           ot_mopread();
INT32           ot_mopwrite();
INT32           ot_read();
INT32           ot_readCapacity();
INT32           ot_setAttributes();
INT32           ot_setOtTime();
void            ot_setSystemArea();
INT32           ot_setTimeAndDate();
INT32           ot_takeOffline();
INT32           ot_testready();
INT32           ot_unlock_cart();
void            ot_unlockfs();
INT32           ot_write();
void            makeLocalName();
UINT32          pow();
#if SUN
void            strcpy();
#endif



/* functions from VENEER.c */
INT32           otfs_mount_lck();
INT32           otfs_root_lck();
INT32           otfs_statfs_lck();
INT32           otfs_sync_lck();
INT32           otfs_vget_lck();
INT32           otvn_access_lck();
INT32           otvn_bmap_lck();
INT32           otvn_close_lck();
INT32           otvn_create_lck();
INT32           otvn_fid_lck();
INT32           otvn_fsync_lck();
INT32           otvn_getattr_lck();
INT32           otvn_inactive_lck();
INT32           otvn_link_lck();
INT32           otvn_lookup_lck();
INT32           otvn_mkdir_lck();
INT32           otvn_rdwr_lck();
INT32           otvn_readdir_lck();
INT32           otvn_readlink_lck();
INT32           otvn_remove_lck();
INT32           otvn_rename_lck();
INT32           otvn_rmdir_lck();
INT32           otvn_setattr_lck();
INT32           otvn_strategy_lck();
INT32           otvn_symlink_lck();

INT32           ot_clearContext();
UINT32          ot_lookupContext();
INT32           ot_parseAndSetContext();
INT32           ot_setContext();
INT32           ot_tohex();

#endif /* HP || SUN */

#if MACINTOSH

/* functions from O_SYS.c */
struct vnode    *bdevvp(int);
INT16           bzero(char *,INT32);
void            DPRINTF(char *);
char            *kmem_alloc(UINT32, UINT16); 
int             kmem_free(void *,UINT32); 
INT32           strcmp(char *,char *);
void            strcpy(char *,char *);
INT32           strlen(char *);
INT32           uiomove(char *,INT32,enum uio_rw,struct uio *);

int             destroyAnOTFS(struct otfs *);
INT32           freevfs(struct otfs *);
INT32           ot_fillBasicFS(struct otfs *,int,int,UINT32);
INT32           ot_getVolInfo(struct otfs *,struct macmountdata *);
INT32           makeAnOTFS(struct otfs **,int,struct macmountdata *);
void            makeLocalName(char *,int);
INT32           mopRead(int,int,HVCB *,unsigned long,unsigned long,
                    void *,unsigned long *);
INT32           mopWrite(int,int,HVCB *,unsigned long,unsigned long,
                    void *,unsigned long);
int             rouseAnHVCB(HVCB *,int,int);
int             rouseAnOTFS(struct otfs *,int);
INT32           setMountFlag(struct otfs *,struct macmountdata *);
void            trashvnode(struct vnode *);

INT32           otvn_create_lck(struct vnode *,char *,struct vattr *,struct vnode **,struct vnode **,int);
INT32           otvn_lookup_lck(struct vnode *,char *,struct vnode **);
INT32           otvn_lookup_assoc_lck(struct vnode *,char *,struct vnode **);

INT32           otfs_mount(struct macmountdata *);
INT32           otfs_unmount(struct vfs *);
INT32           pit_write(struct otfs *fs,UCHAR8 newtype);
INT32           ot_clearContext(enum ctextType,struct otfs *,struct otnode *);
INT32           ot_erase(struct otfs *,int,UINT32,UINT32);
INT32           ot_freedev(struct vnode *);
INT32           ot_getAttributes(struct otnode *,struct vattr *);
UINT32          ot_lookupContext(struct otfs *,UINT32,UINT32,char *,UINT32);
INT32           ot_memCompare(char *,char *,INT32);
INT32           ot_read(struct otfs *,UINT32,char *,UINT32 *);
INT32           ot_setAttributes(struct otnode *,struct vattr *);
void            ot_setSystemArea(struct otnode *);
INT32           ot_takeOffline(struct otfs *);
INT32           ot_testready(struct otfs *);
INT32           ot_write(struct otfs *,UINT32,char *,UINT32);
void            initvfs(void);
void            initvnodes(void);

#endif /* MACINTOSH */

#if IBM

/* functions from O_SYS.c */

void            DoError(char *);
int             DPRINTF(char *,...);

INT16           bzero(char *,INT32);
char            *kmem_alloc(UINT32, UINT16);
void            kmem_free(char *,UINT32);
INT32           strcmp(char *,char *);
void            strcpy(char *,char *);
INT32           strlen(char *);
INT32           uiomove(char *,INT32,enum uio_rw,struct uio *);

INT32           ot_clearContext(enum ctextType,struct otfs *,struct otnode *);
INT32           ot_erase(struct otfs *,int,UINT32,UINT32);
INT32           ot_freedev(INT32);
INT32           ot_getAttributes(struct otnode *,struct vattr *);
INT32           ot_getVolInfo(struct otfs *,INT16,char *,UINT32,UINT32);
INT32           ot_getTimeAndDate(struct otnode *,struct vattr *);
INT32           ot_lock_cart(struct otfs *,INT32);
void            ot_lockfs(struct otfs *);
INT32           ot_lookupContext(struct otfs *,INT32,INT32,char *,INT32);
INT32           ot_memCompare(char *,char *,INT32);
INT32           ot_mopread(INT32,char *,INT32, *INT32);
INT32           ot_mopwrite(INT32,char *,UINT32,UINT32);
INT32           ot_mount(struct otfs *,char *,INT32,dev_t,INT32,INT32);
INT32           ot_read(struct otfs *,UINT32,char *, *UINT32);
INT32           ot_readCapacity(struct otfs *);
INT32           ot_setAttributes(struct otnode *,struct vattr *);
INT32           ot_setDate(struct otnode *,struct vattr *);
INT32           ot_setTime(struct otnode *,struct vattr *);
INT32           ot_takeOffline(struct otfs *);
INT32           ot_testready(struct otfs *,INT32 *);
INT32           ot_unlock_cart(struct otfs *,INT32);
void            ot_unlockfs(struct otfs *);
INT32           ot_write(struct otfs *,UINT32,char *,UINT32);
INT32           otfs_mount(struct vfs *,char *,INT32,INT32,dev_t,INT32);
INT32           otfs_unmount(struct vfs *);
INT32           pit_write(struct otfs *fs,UCHAR8 newtype);

#endif /* IBM */

/*
   all core code routines are the same, what follows is 
   a selection of either ANSI prototypes or empty K&R types
*/

#ifndef ANSIC


/* functions from O_DIR.c */
INT32           ot_addDirentry();
INT32           ot_deleteDirentry();
INT32           ot_dirempty();
INT32           ot_direntry();
INT32           ot_dirlook();
INT32           ot_getDirentry();
UINT32          ot_fileName();
UCHAR8          *ot_getFileID();

/* functions from O_AD.c */
void    otd_printADs();
UINT32  ot_sizeOfAD();
UINT32  ot_numADs();
UINT32  ot_ICBHasADs();
INT32   ot_addToADL();
INT32   ot_consolidateADL();
INT32   ot_searchADL();
INT32   ot_deleteADs();
INT32   ot_insertADs();
INT32   ot_truncateADL();

/* functions from O_ICB.c */
INT32           ot_indICBWr();
INT32           ot_lastInBlock();
INT32           ot_makeICBVsnBlock();
INT32           ot_ICBDelete();
INT32           ot_ICBRdWr();
INT32           ot_ICBWt();
INT32           ot_searchLast();
INT32           ot_searchMO();
INT32           ot_searchVersion();
INT32           ot_validICB();
INT32           ot_isICB();

/* functions from O_STRUCT.c */
void            ot_xlate();
void            ot_xlateBlock();
INT16           getint();
UINT16          getuint();
INT32           getlong();
UINT32          getulong();
void            putint();
void            putlong();
void            swapUINT16();
void            swapUINT32();
void            swapUINT64();
void            ot_copy();
void            FillTag();
UINT16          ot_goodTag();

/* functions from O_VFSOPS.c */
INT32           otfs_invalop();
INT32           otfs_root();
INT32           otfs_statfs();
INT32           otfs_sync();
INT32           otfs_vget();
INT32           ot_active();
INT32           ot_addToList();
INT32           ot_busy();
UINT32          ot_calcSpaceToFlush();
INT32           ot_countFreeSectors();
void            ot_dequeueOTNode();
INT32           ot_eraseUnerased();
struct space    *ot_getContiguous();
struct space    *ot_getSpace();
void            ot_enqueueOTNode();
INT32           ot_putOnline();
INT32           ot_rdHighwaterMark();
INT32           ot_rdwrOBase();
INT32           ot_readBitmap();
INT32           ot_writeBitmap();
INT32           ot_wtHighwaterMark();
void            killBitmap();
void            killSpaceList();
UINT32          power();
INT32           returnSectors();
void            uioInit();
void            vattrInit();

/* functions from O_VNDOPS.c */
INT32           otvn_access();
INT32           otvn_close();
INT32           otvn_create();
INT32           otvn_fid();
INT32           otvn_fsync();
INT32           otvn_getattr();
INT32           otvn_inactive();
INT32           otvn_invalop();
INT32           otvn_lookup();
INT32           otvn_lookup_assoc();
INT32           otvn_mkdir();
INT32           otvn_open();
INT32           otvn_rdwr();
INT32           otvn_readdir();
INT32           otvn_remove();
INT32           otvn_rename();
INT32           otvn_rmdir();
INT32           otvn_setattr();
INT32           ot_check_permissions();
INT32           ot_delete();
INT32           ot_deleteExtAttrICBs();
INT32           ot_deleteData();
INT32           ot_getAndFillOTNode();
INT32           ot_getName();
INT32           ot_getNumFiles();
INT32           ot_getOTNode();
INT32           ot_readData();
INT32           ot_readVerify();
void            ot_release();
INT32           ot_setFileSize();
INT32           ot_setupDirentryOTNode();
INT32           ot_sfrdwr();
INT32           ot_writeData();
void            ot_fillOtNode();

#endif /* ANSI C not defined */

#ifdef ANSIC

/* functions from O_DIR.c */
INT32   ot_addDirentry(struct otfs *,struct otnode *,
                       struct otnode *,struct otnode *);
INT32   ot_deleteDirentry(struct otfs *,struct otnode *,char *);
INT32   ot_dirempty(struct otfs *,struct otnode *);
INT32   ot_direntry(struct otfs *,struct otnode *,char *,
                    struct vattr *,struct otnode **,
                    enum vtype,struct otnode **);
INT32   ot_dirlook(struct otfs *,struct otnode *,char *,
                   struct otnode **,enum vtype,UINT32);
INT32   ot_getDirentry(struct otfs *,struct otnode *,
                       struct FileIDDesc **,UINT32 *,
                       UINT32 *,char *,UINT32,enum searchType);
UINT32  ot_fileName(UCHAR8 * , int, UCHAR8 *);
UCHAR8  *ot_getFileID( struct FileIDDesc *);


/* functions from O_AD.c */
void    otd_printADs(char *,UINT16,UINT32,void *);
UINT32  ot_sizeOfAD(UINT16 ADType);
UINT32  ot_numADs(struct otnode *otp);
UINT32  ot_ICBHasADs(struct otnode *otp);
INT32   ot_addToADL(struct otnode *,UINT32,UINT32,struct space *);
INT32   ot_consolidateADL(struct otnode *);
INT32   ot_searchADL(struct otnode *,UINT32,UINT32*,UINT32*);
INT32   ot_deleteADs(struct otnode *,UINT32,UINT32);
INT32   ot_insertADs(struct otnode *,UINT32,UINT32);
INT32   ot_truncateADL(struct otnode *otp,UINT32 ADIndex);

/* functions from O_ICB.c */
INT32   ot_indICBWr(struct otfs *, struct IndirectEntry *, UINT32, 
                      struct space *, UINT16);
INT32   ot_lastInBlock(register struct otfs *,UINT32,UINT16 *);
INT32   ot_makeICBVsnBlock(struct otfs *,UINT32,UINT32,
                             UINT16,UINT32 *);
INT32   ot_ICBDelete(struct otfs *,struct otnode *);
INT32   ot_ICBRdWr(struct otfs *,struct otnode *,
                     enum uio_rw,UINT32);
INT32   ot_ICBWt(char *,UINT32,UINT32,struct otfs *);
INT32   ot_searchLast(struct otfs *,UINT32,UINT32 *,char *,
                      enum uio_rw,UINT32 *);
INT32   ot_searchMO(struct otfs *,UINT32,UINT32 *,char *,
                    enum uio_rw);
INT32   ot_searchVersion(struct otfs *,UINT32,UINT32 *,
                         char *,UINT32);
INT32   ot_validICB(UINT16 tagid, struct EntryHdr *hdr, UINT32 location);
INT32   ot_isICB(void *ptr);

/* functions from O_STRUCT.c */
void    ot_xlate(int,INT32,char *,UINT32,UINT32);
void    ot_xlateBlock(char *,UINT16,int,UINT16);
INT16   getint(char *);
UINT16  getuint(char *);
INT32   getlong(char *);
UINT32  getulong(char *);
void    putint(UINT16,char *);
void    putlong(UINT32,char *);
void    swapUINT16(UINT16 *); 
void    swapUINT32(UINT32 *);
void    swapUINT64(UINT32 *,UINT32 *);
void    ot_copy(char *,char *,INT32);
void    FillTag( UINT16, UINT16, UINT16, UINT16, UINT16, UINT32, struct Tag *);
UINT16  ot_goodTag(UINT16 expected_tagid, void *ptr, UINT32 Location);
UINT16  isTag( struct Tag *);

/* functions from O_VFSOPS.c */
INT32   otfs_invalop();
INT32   otfs_root(struct vfs *,struct vnode **,UINT32);
INT32   otfs_statfs(struct vfs *,struct statfs *);
INT32   otfs_sync(struct vfs *);
INT32   otfs_vget(struct vfs *,struct vnode **,struct fid *);
INT32   ot_active(struct otnode *);
INT32   ot_addToList(UINT32,UINT32,struct space **,struct otfs *);
INT32   ot_busy(struct otfs *);
UINT32  ot_calcSpaceToFlush(struct otfs *,UINT32);
INT32   ot_countFreeSectors(struct otfs *);
void    ot_dequeueOTNode(struct otnode **,struct otnode *);
INT32   ot_eraseUnerased(struct otfs *);
struct space *ot_getContiguous(struct otfs *,UINT32);
struct space *ot_getSpace(struct otfs *,UINT32,enum spRequestType);
void    ot_enqueueOTNode(struct otnode **,struct otnode *);
INT32   ot_putOnline(struct otfs *);
INT32   ot_rdHighwaterMark(struct otfs *);
INT32   ot_rdwrOBase(struct otfs *,enum uio_rw,struct otnode **, struct obase *);
INT32   ot_readBitmap(struct otfs *,UINT32,enum bitmapType,int);
INT32   ot_writeBitmap(struct otfs *,enum bitmapType);
INT32   ot_wtHighwaterMark(struct otfs *);
void    killBitmap(struct otfs *,enum bitmapType);
void    killSpaceList(struct space **);
UINT32  power(UINT32,UINT32);
INT32   returnSectors(struct otfs *,struct space *,UINT32,UINT32,enum bitmapType);
void    uioInit(struct uio *,struct iovec *,char *,INT32,INT32);
void    vattrInit(struct vattr *);

/* functions from O_VNDOPS.c */
INT32   otvn_access(struct vnode *,INT32,struct ucred *);
INT32   otvn_close(struct vnode *,INT32,struct ucred *);
INT32   otvn_create(struct vnode *,char *,struct vattr *,
                    enum vcexcl,INT32,struct vnode **,
                    struct vnode **,struct ucred *,int);
INT32   otvn_fid(struct vnode *,struct fid **);
INT32   otvn_fsync(struct vnode *,struct ucred *);
INT32   otvn_getattr(struct vnode *,struct vattr *,struct ucred *);
INT32   otvn_inactive(struct vnode *,struct ucred *);
INT32   otvn_invalop(void);
INT32   otvn_lookup(struct vnode *,char *,struct vnode **,
                    struct ucred *,UINT32);
INT32   otvn_lookup_assoc(struct vnode *,char *,struct vnode **,
                          struct ucred *,UINT32);
INT32   otvn_mkdir(struct vnode *,char *,struct vattr *,
                   struct vnode **,struct ucred *);
INT32   otvn_open(struct vnode **,INT32,struct ucred *);
INT32   otvn_rdwr(struct vnode *,struct uio *,enum uio_rw,
                  INT32,struct ucred *);
INT32   otvn_readdir(struct vnode *,struct uio *,struct ucred *);
INT32   otvn_remove(struct vnode *,char *,struct ucred *);
INT32   otvn_rename(struct vnode *,char *,struct vnode *,char *,
                    struct ucred *);
INT32   otvn_rmdir(struct vnode *,char *,struct ucred *);
INT32   otvn_setattr(struct vnode *,struct vattr *,struct ucred *);
INT32   ot_check_permissions(struct vnode *,struct ucred *);
INT32   ot_delete(struct otfs *,struct otnode *,char *);
INT32   ot_deleteExtAttrICBs(struct otfs *,struct otnode *);
INT32   ot_deleteData(struct otfs *,struct otnode *);
INT32   ot_getAndFillOTNode(struct otfs *,struct otnode *,
                            struct otnode **,struct otnode **,
                            char *,enum vtype,
                            struct FileIDDesc *,UINT32);
INT32   ot_getName(struct otfs *,struct otnode *,UINT32);
INT32   ot_getNumFiles(struct otfs *,UINT32,enum sumEntryType,UINT32 *, UINT16 *);
INT32   ot_getOTNode(int,struct otfs *,char *,UINT32,UINT32,enum vtype,
                     struct otnode *,struct otnode **);
INT32   ot_readData(struct otfs *,struct otnode *,struct uio *);
INT32   ot_readVerify(struct vnode *,struct uio *);
void    ot_release(struct otnode *);
INT32   ot_setFileSize(struct otfs *,struct otnode *,UINT32,
                       enum spRequestType);
INT32   ot_setupDirentryOTNode(struct otfs *,struct otnode **,
                               struct vattr *,enum vtype,char *,UINT32);
INT32   ot_sfrdwr(struct otnode *,char *,enum sftype,enum uio_rw,
                  UINT32,UINT16,UINT16,UINT16 *);
INT32   ot_writeData(struct otfs *,struct otnode *, struct uio *);
void    ot_fillOtNode(struct otfs *, struct otnode *,char *,UINT32,enum vtype,
                   UINT32,UINT32);

#endif /* ANSI C defined */

#endif /* _OPROTOH_ */
