/********************************************************************/
/*  vdev.c - Device file vnodes                                     */
/*                                                                  */
/*      Unpublished Confidential Information of Hewlett-Packard     */
/*      Company. Do not disclose.  Copyright (c) Hewlett-Packard    */
/*      Company 1996. All rights reserved                           */
/*                                                                  */
/* The contents of this software are proprietary and confidential   */
/* the Hewlett- Packard Company, and are limited in distribution to */
/* those with a direct need to know.  Individuals having access to  */
/* this software are responsible for maintaining the                */
/* confidentiality of the content and for keeping the software      */
/* secure when not in use.  Transfer to any party is strictly       */
/* forbidden other than as expressly permitted in writing by        */
/* Hewlett-Packard Company.  Unauthorized transfer to or possession */
/* by any unauthorized party may be a criminal offense.             */
/*                                                                  */
/*                   RESTRICTED RIGHTS LEGEND                       */
/*                                                                  */
/*      Use,  duplication,  or disclosure by the                    */
/*      U. S. Government is subject to restrictions as set forth    */
/*      in subparagraph (c) (1) (ii) in the Rights in Technical     */
/*      Data and Computer Software clause in DFARS 252.227-7013     */
/*      or any other successor clause.                              */
/*                                                                  */
/*                       HEWLETT-PACKARD COMPANY                    */
/*                       3000 Hanover St.                           */
/*                       Palo Alto, CA  94304 U.S.A.                */
/*                                                                  */
/*      Rights for non-DOD U.S. Government Departments and Agencies */
/*      are as set forth in FAR 52.227-19 (c) (1,2) or any other    */
/*      successor clause.                                           */
/*                                                                  */
/*                                                                  */
/*                        vdev.c                                    */
/*                                                                  */
/* This file contains device file vnodes. These are provided        */
/* for NSR so that it may use the fields in its structures          */
/* which require it. Note that currently, only the rdev field       */
/* is used.                                                         */
/*                                                                  */
/* This is all provided in the following way:                       */
/*                                                                  */
/* 1. A static array of vnodes is created at poweron.               */
/*                                                                  */
/* 2. The function init_vdevs() must be caled to initialize         */
/*    the array at poweron.                                         */
/*                                                                  */
/* 3. A function is provided, bdevvp(), which returns a devvp       */
/*    based on a supplied device number.                            */
/*                                                                  */
/*                     DVM 6/26/92                                  */
/*                                                                  */
/********************************************************************/
/*
 $Source: /projects/HMS/nsr/udfOld/src/nsrSys/vdev.c,v $
 $Revision: 1.4 $       $Author: hmgr $
 $State: Exp $          $Locker:  $
 $Date: 96/05/30 14:53:08 $
 ********************************************************************/

#include "../nsrHdrs/def.h"
#include "../nsrHdrs/dev.h"
#include "../nsrHdrs/vdev.h"

#include "Utils.h"

static struct vnode *devvp[NUM_DEVS];

/* NOTE: This should probably make use of andyp's scan for devices */
/*       by the initiator, though we may want all of these defined */
/*       anyway. ?? DVM 6/26/92 */

void init_vdevs(void) 
{
    UINT16 i;
    
    for (i=0; i<NUM_DEVS; i++) {
        devvp[i] = (struct vnode *)kmem_alloc((UINT32)sizeof(struct vnode),0);
        VN_INIT(devvp[i],NULL,VBLK,DEVFROMID(i));
    }
}

struct vnode *bdevvp(dev_t device) 
{
    return (devvp[SCSIID(device)]);
}
