/********************************************************************/
/*  icbtest.c - tests out the icb stuff.                            */
/*                                                                  */
/*      Unpublished Confidential Information of Hewlett-Packard     */
/*      Company. Do not disclose.  Copyright (c) Hewlett-Packard    */
/*      Company 1996. All rights reserved                           */
/*                                                                  */
/* The contents of this software are proprietary and confidential   */
/* the Hewlett- Packard Company, and are limited in distribution to */
/* those with a direct need to know.  Individuals having access to  */
/* this software are responsible for maintaining the                */
/* confidentiality of the content and for keeping the software      */
/* secure when not in use.  Transfer to any party is strictly       */
/* forbidden other than as expressly permitted in writing by        */
/* Hewlett-Packard Company.  Unauthorized transfer to or possession */
/* by any unauthorized party may be a criminal offense.             */
/*                                                                  */
/*                   RESTRICTED RIGHTS LEGEND                       */
/*                                                                  */
/*      Use,  duplication,  or disclosure by the                    */
/*      U. S. Government is subject to restrictions as set forth    */
/*      in subparagraph (c) (1) (ii) in the Rights in Technical     */
/*      Data and Computer Software clause in DFARS 252.227-7013     */
/*      or any other successor clause.                              */
/*                                                                  */
/*                       HEWLETT-PACKARD COMPANY                    */
/*                       3000 Hanover St.                           */
/*                       Palo Alto, CA  94304 U.S.A.                */
/*                                                                  */
/*      Rights for non-DOD U.S. Government Departments and Agencies */
/*      are as set forth in FAR 52.227-19 (c) (1,2) or any other    */
/*      successor clause.                                           */
/*                                                                  */
/********************************************************************/
/*
 $Source: /projects/HMS/nsr/udfOld/src/nsrTools/icbtest.c,v $
 $Revision: 1.6 $       $Author: hmgr $
 $State: Exp $          $Locker:  $
 $Date: 96/05/30 14:53:16 $
 ********************************************************************/

#include "def.h"
#include "o_vfsops.h"
#include "vnode.h"
#include "nsr.h"
#include "o_proto.h"
/* #include "magvol.h" */
#include "nsrerrno.h"
#include "Debug.h"
#include "o_node.h"
#include "makefs.h"

main()
{
    struct vfs *vfsp;
    struct vnode *vnp;
    struct uio uios;
    struct ucred ucreds;
    char *bufp;
    struct iovec iovecs;
    struct vnode *dvnp;
    struct vattr vas;
    struct vnode *vpp;
    struct vnode *avpp;

    INT32 error;

    /* allocation a g.p. buffer */
    bufp= (char *) kmem_alloc( 1024, 0);
    bzero( bufp, 1024);

    /* try doing a mount */

    /* allocate a vfs and otfs structure */
    vfsp = (struct vfs *) kmem_alloc( sizeof( struct vfs), 0);

    error = otfs_mount( vfsp, "TEST", 1, 1, "DUMMY");

    /* get the root */
    if (!error) 
      error = otfs_root( vfsp, &vnp, 0);

    /* read the root directory */
    /* just want the first entry */

    bzero( (caddr_t) &uios, (INT32) sizeof( struct uio));
    uios.uio_iovcnt = 1;
    uios.uio_offset = 0;
    uios.uio_resid = 1024;
    uios.uio_iov = &iovecs;
    iovecs.iov_base = bufp;
    iovecs.iov_len = 1024;

    if(!error) 
      error = otvn_readdir( vnp, &uios, &ucreds);

    /*create a directory in the root */

    /* fill out the attributes structure */
    vas.va_type=VDIR;

    if( !error)
      error = otvn_mkdir( vnp, "DIRECTORY1", &vas, &dvnp, &ucreds);
    if( !error)
      error = otvn_mkdir( vnp, "DIRECTORYP2", &vas, &dvnp, &ucreds);
    if( !error)
      error = otvn_mkdir( vnp, "DIRECTORYPA3", &vas, &dvnp, &ucreds);
    if( !error)
      error = otvn_mkdir( vnp, "DIRECTORYPAD4", &vas, &dvnp, &ucreds);
    if( !error)
      error = otvn_mkdir( vnp, "DIRECTORY5", &vas, &dvnp, &ucreds);
    if( !error)
      error = otvn_mkdir( vnp, "DIRECTORYP6", &vas, &dvnp, &ucreds);
    if( !error)
      error = otvn_mkdir( vnp, "DIRECTORYPA7", &vas, &dvnp, &ucreds);
    if( !error)
      error = otvn_mkdir( vnp, "DIRECTORYPAD8", &vas, &dvnp, &ucreds);
    if( !error)
      error = otvn_mkdir( vnp, "DIRECTORY9", &vas, &dvnp, &ucreds);
    if( !error)
      error = otvn_mkdir( vnp, "DIRECTORY10", &vas, &dvnp, &ucreds);
    if( !error)
      error = otvn_mkdir( vnp, "NDIRECTORY1", &vas, &dvnp, &ucreds);
    if( !error)
      error = otvn_mkdir( vnp, "NDIRECTORYP2", &vas, &dvnp, &ucreds);
    if( !error)
      error = otvn_mkdir( vnp, "NDIRECTORYPA3", &vas, &dvnp, &ucreds);
    if( !error)
      error = otvn_mkdir( vnp, "NDIRECTORYPAD4", &vas, &dvnp, &ucreds);
    if( !error)
      error = otvn_mkdir( vnp, "NDIRECTORY5", &vas, &dvnp, &ucreds);
    if( !error)
      error = otvn_mkdir( vnp, "NDIRECTORYP6", &vas, &dvnp, &ucreds);
    if( !error)
      error = otvn_mkdir( vnp, "NDIRECTORYPA7", &vas, &dvnp, &ucreds);
    if( !error)
      error = otvn_mkdir( vnp, "NDIRECTORYPAD8", &vas, &dvnp, &ucreds);
    if( !error)
      error = otvn_mkdir( vnp, "NDIRECTORY9", &vas, &dvnp, &ucreds);
    if( !error)
      error = otvn_mkdir( vnp, "NDIRECTORY10", &vas, &dvnp, &ucreds);


    /* now delete one */

    if( !error)
      error = otvn_rmdir( vnp, "DIRECTORY5", &ucreds);

    /* now create a chain of directories that go eight levels deep */

    if( !error)
        error = otvn_mkdir( vnp, "LEVEL1", &vas, &dvnp, &ucreds);
    vnp = dvnp;
    if( !error)
        error = otvn_mkdir( vnp, "LEVEL2", &vas, &dvnp, &ucreds);
    vnp = dvnp;
    if( !error)
        error = otvn_mkdir( vnp, "LEVEL3", &vas, &dvnp, &ucreds);
    vnp = dvnp;
    if( !error)
        error = otvn_mkdir( vnp, "LEVEL4", &vas, &dvnp, &ucreds);
    vnp = dvnp;
    if( !error)
        error = otvn_mkdir( vnp, "LEVEL5", &vas, &dvnp, &ucreds);
    vnp = dvnp;
    if( !error)
        error = otvn_mkdir( vnp, "LEVEL6", &vas, &dvnp, &ucreds);
    vnp = dvnp;
    if( !error)
        error = otvn_mkdir( vnp, "LEVEL7", &vas, &dvnp, &ucreds);
    vnp = dvnp;
    if( !error)
        error = otvn_mkdir( vnp, "LEVEL8", &vas, &dvnp, &ucreds);

    /* now create a file */
    vas.va_type=VREG;
    if( !error) 
      error = otvn_create( vnp, "FILE1", &vas, NONEXCL, VWRITE, &vpp, &avpp, &ucreds, 0);

    /* fill a buffer and write it */
    if (!error) {
        memcpy( bufp, "TESTSTRING", 10);
        uioInit( &uios, &iovecs, bufp, 0, 10);
        error = otvn_rdwr( vpp, &uios, UIO_WRITE, IO_APPEND, &ucreds);
    }
    
    error = otfs_unmount( vfsp);

    if ( error ) 
        printf("icbtest: error 0x%x (%d)\n",error,error);
    printf("Done!\n");

}
