/********************************************************************/
/*  hex.c - Dumps out in hex and ascii                              */
/*                                                                  */
/*      Unpublished Confidential Information of Hewlett-Packard     */
/*      Company. Do not disclose.  Copyright (c) Hewlett-Packard    */
/*      Company 1996. All rights reserved                           */
/*                                                                  */
/* The contents of this software are proprietary and confidential   */
/* the Hewlett- Packard Company, and are limited in distribution to */
/* those with a direct need to know.  Individuals having access to  */
/* this software are responsible for maintaining the                */
/* confidentiality of the content and for keeping the software      */
/* secure when not in use.  Transfer to any party is strictly       */
/* forbidden other than as expressly permitted in writing by        */
/* Hewlett-Packard Company.  Unauthorized transfer to or possession */
/* by any unauthorized party may be a criminal offense.             */
/*                                                                  */
/*                   RESTRICTED RIGHTS LEGEND                       */
/*                                                                  */
/*      Use,  duplication,  or disclosure by the                    */
/*      U. S. Government is subject to restrictions as set forth    */
/*      in subparagraph (c) (1) (ii) in the Rights in Technical     */
/*      Data and Computer Software clause in DFARS 252.227-7013     */
/*      or any other successor clause.                              */
/*                                                                  */
/*                       HEWLETT-PACKARD COMPANY                    */
/*                       3000 Hanover St.                           */
/*                       Palo Alto, CA  94304 U.S.A.                */
/*                                                                  */
/*      Rights for non-DOD U.S. Government Departments and Agencies */
/*      are as set forth in FAR 52.227-19 (c) (1,2) or any other    */
/*      successor clause.                                           */
/*                                                                  */
/********************************************************************/
/*
 $Source: /projects/HMS/nsr/udfOld/src/nsrTools/sniff/hex.c,v $
 $Revision: 1.3 $       $Author: hmgr $
 $State: Exp $          $Locker:  $
 $Date: 96/05/30 14:53:20 $
 ********************************************************************/

#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <ctype.h>

#define MAXSECS 10
#define SECSIZE 512
#define SPACECHAR "."

void main( int argc, char *argv[])
{
    int secsize;
    unsigned char iobuff[SECSIZE];
    int inner, outer, i, j;
    long int secnum, bsecnum;
    int sectorsread;

    /* make sure there are no arguments, if any send help */
    
    if( argv[1] != NULL) {
      system( "cat //users//edb//nitro//sw/src//nsrTest//sniff//hex.man | more");
      exit(-1);
    }

    /* get the sector size */

    secsize = getw( stdin);
    sectorsread = getw( stdin);
    printf("Sector size is %d\n", secsize);
    printf("Reading %d sectors.\n", sectorsread);

    
    for(j=0; j< sectorsread; j++ ) {

        secnum = getw( stdin);
        bsecnum = getw( stdin);
        
        /* fill the buffer */
        
        for(i=0; i<secsize; iobuff[i++] = getchar());
        
        /* print the results now */
        
        printf("Sector %ld (0x%lx) Offset 0x%lx Physical %ld (0x%lx)\n", secnum,
               secnum, secnum*secsize, bsecnum, bsecnum);
        for( outer=0; outer < secsize/16; outer++) {
            printf("%.3X  ", outer*16);
            for( inner = 0; inner < 16; inner++) {
                if( inner == 8)
                  printf("  ");
                printf("%.2X ", iobuff[outer*16+inner]);
            }
            printf("  ");
            for( inner = 0; inner < 16; inner++) {
                if( inner == 8)
                  printf(" ");
                if( isgraph((int) iobuff[outer*16+inner])) {
                    printf("%c", iobuff[outer*16+inner]);
                } else {
                    printf(SPACECHAR);
                }
            }
            printf("\n");
        }
    }
    exit(0);
}

    
